#! /usr/bin/env python3 -B

from testlib import check, runtests, check_text_file, check_img_file, check_json_file


import program

###############################################################################
def test_nome_cognome_matricola():
    assert program.nome        != 'NOME',      "ATTENZIONE, NON HAI INSERITO IL TUO NOME NEL FILE program.py !!!"
    assert program.cognome     != 'COGNOME',   "ATTENZIONE, NON HAI INSERITO IL TUO COGNOME NEL FILE program.py !!!"
    assert program.matricola   != 'MATRICOLA', "ATTENZIONE, NON HAI INSERITO LA TUA MATRICOLA NEL FILE program.py !!!"
    return 0

###############################################################################

def test_es0a_1():
    ''' \nPrimo test della funzione es0 con  
    lst=[ 1,2,'tre','quattro',2,'uno',0] '''
    ris = program.es0([ 1,2,'tre','quattro',2,'uno',0])
    check(ris, ['uno', 'due', 3, 4, 'due', 1, 'zero'], None, " la risposta non e' corretta")
    return 1

def test_es0a_2():
    ''' \nSecondo test della funzione es0 con   
    lst=[1,2,'uno','due',3,4,'tre','quattro',5,6] '''
    ris = program.es0([1,2,'uno','due',3,4,'tre','quattro',5,6])
    check(ris, ['uno', 'due', 1, 2, 'tre', 'quattro', 3, 4, 'cinque', 'sei'],
     None, " la risposta non e' corretta")
    return 1

def test_es0a_3():
    ''' \nTerzo test della funzione es0 con 
    lst=[9,8,7,'sei','uno','tre',3,7,0,'zero','zero','zero'] '''
    ris = program.es0([9,8,7,'sei','uno','tre',3,7,0,'zero','zero','zero'])
    check(ris, ['nove', 'otto', 'sette', 6, 1, 3, 'tre', 'sette', 'zero', 0, 0, 0]
    , None, " la risposta non e' corretta")
    return 1

######################################################################################

def test_es1a_1():
    ''' \nPrimo test della funzione es1 con  nint=10 e ndivi=2 
    '''
    ris = program.es1(10,2)
    check(ris, [2, 3, 5, 7, 11, 13, 17, 19, 23, 29], None, " la risposta non e' corretta")
    return 1

def test_es1a_2():
    ''' \nSecondo test della funzione es1 con   con nint=10 e ndivi=3 
    '''
    ris = program.es1(10,3)
    check(ris, [4, 9, 25, 49, 121, 169, 289, 361, 529, 841],
     None, " la risposta non e' corretta")
    return 1

def test_es1a_3():
    ''' \nTerzo test della funzione es1 con nint=10 e ndivi=4
    '''
    ris = program.es1(10,4)
    check(ris, [6, 8, 10, 14, 15, 21, 22, 26, 27, 33]
    , None, " la risposta non e' corretta")
    return 1
   
###############################################################################
def test_es2a_1():
    ''' \nPrimo test della funzione es2 con   file di testo 'f1.txt' '''
    ls1=['b', 'abba', 'babc','ccc', 'bba', 'bb' ]
    ris = program.es2('f1.txt')
    check(ris, ['lupo', 'casa', 'ape', 'bue', 'foca'], None, " la risposta non e' corretta")
    return 2

def test_es2a_2():
    ''' \nSecondo test della funzione es2 con   file di testo 'f2.txt' '''
    ris = program.es2('f2.txt')
    check(ris, ['oca', 'gatto', 'ippopotamo', 'elefante', 'coccodrillo', 'aquila', 
    'balena', 'cane', 'topo'], None, " la risposta non e' corretta")
    return 2

def test_es2a_3():
    ''' \nTerzo test della funzione es2 con   file di testo 'f3.txt' '''
    ris = program.es2('f2.txt')
    check(ris, ['oca', 'gatto', 'ippopotamo', 'elefante', 'coccodrillo', 'aquila', 
    'balena', 'cane', 'topo'], None, " la risposta non e' corretta")
    return 2


######################################################################################


def test_es3a_1():
    ''' \nPrimo test della funzione es3  dove si utilizza il file  'fmat1.txt' :'''
    returned = program.es3('fmat1.txt')
    check(returned, [[1, 20, 3, 40, 5], [60, 7, 8, 9, 10], [11, 12, 13, 14, 15]] , 
          None, "la risposta della funzione  non e' corretta")
    return 2

def test_es3a_2():
    ''' \nSecondo test della funzione es3  dove si utilizza il file  'fmat2.txt' :'''
    returned = program.es3('fmat2.txt')
    check(returned, [[1], [2], [3], [4], [5]] , None, "la risposta della funzione  non e' corretta")
    return 2
    
def test_es3a_3():
    ''' \nTerzo test della funzione es3  dove si utilizza il file  'fmat3.txt' :'''
    returned = program.es3('fmat3.txt')
    check(returned, 
    [[1, 2, 3, 4, 5], [1, 2, 3, 4, 5], [], [1, 2, 3, 4, 5], [1, 2, 3, 4, 5], [1, 2, 3, 4, 5], [1, 2, 3, 4, 5]] , 
    None, "la risposta della funzione  non e' corretta")
    return 2



###############################################################################

def test_es4a_1():
    ''' \nPrimo test della funzione es4  con 
    stringa1='Angelo Monti Lorenzo Madeddu Angelo Spognardi e  Andrea Sterbini'
    '''
    returned = program.es4('Angelo Monti Lorenzo Madeddu Angelo Spognardi e  Andrea Sterbini')
    check(returned, '48 63 90 48 48 93 5 39 88' , 
          None, "la risposta della funzione  non e' corretta")
    return 2

def test_es4a_2():
    ''' \nSecondo test della funzione es4  con 
    stringa1='Aa bB Cc dD' 
    '''
    returned = program.es4('Aa bB Cc dD' )
    check(returned, '2 4 6 8' , 
          None, "la risposta della funzione  non e' corretta")
    return 2


def test_es4a_3():
    ''' \nTerzo test della funzione es4  con 
    stringa1='Fondamenti di Programmazione esame del primo semestre primo anno' 
    '''
    returned = program.es4('Fondamenti di Programmazione esame del primo semestre primo anno')
    check(returned, '91 13 150 39 19 63 94 63 38' , 
          None, "la risposta della funzione  non e' corretta")
    return 2

################################################################################


def test_es5a_1():
    ''' \nPrimo test della funzione es1 con 
    lista1=[3,10,8,1,5,3]
    lista2=[1,20,8,3,5,6]''' 
    l1=[3,10,8,1,5,3]
    l2=[1,20,8,3,5,6]
    ris = program.es5(l1,l2)
    check(ris, 4, None, " la risposta non e' corretta")
    check(l1, [3,8,5], None, " la lista lista1 non e' stata modificata correttamente")
    check(l2, [20, 8, 3, 5, 6], None, " la lista lista2 non e' stata modificata correttamente")
    return 2

def test_es5a_2():
    ''' \nSecondo test della funzione es1 con 
    lista1=[1,2,3,4,5,6,7,8,5,6]
    lista2=[5,6,7,8,1,2,3,4,5,6]''' 
    l1=[1,2,3,4,5,6,7,8,5,6]
    l2=[5,6,7,8,1,2,3,4,5,6]
    ris = program.es5(l1,l2)
    check(ris, 8, None, " la risposta non e' corretta")
    check(l1, [5,6,7,8,5,6], None, " la lista lista1 non e' stata modificata correttamente")
    check(l2, [5,6,7,8,5,6], None, " la lista lista2 non e' stata modificata correttamente")
    return 2

def test_es5a_3():
    ''' \nSecondo test della funzione es1 con 
    lista1=[1,2,3,4,5,6,7,8,9]
    lista2=[9,8,7,6,5,4,3,2,1]''' 
    l1=[1,2,3,4,5,6,7,8,9,0,1,2]
    l2=[9,8,7,6,5,4,3,2,1,0,2,1]
    ris = program.es5(l1,l2)
    check(ris, 10, None, " la risposta non e' corretta")
    check(l1, [5,6,7,8,9,0,2], None, " la lista lista1 non e' stata modificata correttamente")
    check(l2, [9,8,7,6,5,0,2], None, " la lista lista2 non e' stata modificata correttamente")
    return 2


################################################################################

tests = [
    test_nome_cognome_matricola,
    test_es0a_1, test_es0a_2, test_es0a_3,
    test_es1a_1, test_es1a_2,  test_es1a_3,
    test_es2a_1, test_es2a_2, test_es2a_3,
    test_es3a_1, test_es3a_2, test_es3a_3,
    test_es4a_1, test_es4a_2, test_es4a_3,
    test_es5a_1, test_es5a_2, test_es5a_3,
    #test_es11a_1, test_es11a_2, test_es11a_3,
    #test_es15_1, test_es15_2, test_es15_3,
]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')

################################################################################


